package ru.amse.smyshlyaev.grapheditor.ui.tool.labeleditor;

import ru.amse.smyshlyaev.grapheditor.graph.ISelectableVertex;
import ru.amse.smyshlyaev.grapheditor.graphdatacalculator.*;
import ru.amse.smyshlyaev.grapheditor.ui.JGraphComponent;


public class VertexLabelEditor extends LabelEditor {
	private ISelectableVertex myVertex;

	public VertexLabelEditor(JGraphComponent component) {
		super(component);
	}
	
	protected int getRectangleX() {
		return myVertex.getX() - 
                VertexDataCalculator.getLabelWidth(
                	    myComponent.getGraphics(), 
                        myVertex
          		 ) / 2;
	}
	
	protected int getRectangleY() {
		return myVertex.getY() - 
                VertexDataCalculator.getLabelHeight(
                	    myComponent.getGraphics(),
                	    myVertex
        		 ) / 2;
	}

	public void setVertex(ISelectableVertex v) {
		myVertex = v;
	}

	public void exitTextField(String newLabel) {
		myVertex.setLabel(newLabel, myComponent.getGraphics());
		
		super.exitTextField(newLabel);
	}
	
	protected String getOldLabel() {
		return myVertex.getLabel();
	}
}